#include "canbusmysqldatabase.h"
#include <string>
#include <stdlib.h>
#include <stdio.h>
#include <string>
#include <iostream>

using namespace std;
using namespace mysqlpp;

namespace  robot{
namespace canbusSpace {

std::string CanbusMySqlDataBase::Name() { return "MySQL Database"; }

int CanbusMySqlDataBase::QueryDB(){
  try
  {
    /***************************打开数据库 start ****************************/
    const char* db = 0, *server = 0, *user = 0, *password = "";
    db = "dreamview_web";
    server = "localhost";
    user = "root";
    password = "Aa123456";

    mysqlpp::Connection conn(false);
    if (conn.connect(db, server, user, password))
    {
      LOG(INFO)<<Name()<<":Canbus opendb dreamview_web succeed";
      mysqlpp::Query query = conn.query("select * from Base_Department;");
      mysqlpp::StoreQueryResult res = query.store();
      cout << "ares.num_rows() = " << res.num_rows() << endl;
        for (size_t i = 0; i < res.num_rows(); i++)
        {
          cout << "Id: " << res[i]["Id"] << "\t - Name: " << res[i]["Name"]
          << "\t - ParentId: " << res[i]["ParentId"] <<endl;
        }

        /* Let's get a count of something */
        query = conn.query("select count(*) as row_count from Base_Department;" ) ;
        StoreQueryResult bres = query.store();
        if(bres.num_rows() > 0)
        {
                  cout << "Total rows: " << bres[0]["row_count"] << endl;
        }

    }
    else
    {
      LOG(INFO)<<Name()<<":Canbus opendb dreamview_web fail";
    }
    /***************************打开数据库 end ******************************/
    conn.disconnect();
    return DATABASE_SUCCESS;
  }
  catch (BadQuery er)
  { // handle any connection or
  // query errors that may come up
    LOG(ERROR)<<Name()<< " Canbus database error. "<< er.what();
    return DATABASE_FAILTURE;
  }
  catch (const BadConversion& er)
  {
  // Handle bad conversions
    LOG(ERROR)<<Name()<< " Canbus database Conversion error: "<< er.what()
             <<"\tretrieved data size: " << er.retrieved
             <<", actual size: " << er.actual_size;
    return DATABASE_FAILTURE;
  }
  catch (const Exception& er)
  {
    // Catch-all for any other MySQL++ exceptions
    LOG(ERROR)<<Name()<< " Canbus database error. "<< er.what();
    return DATABASE_FAILTURE;
  }

}

int CanbusMySqlDataBase::InsertDB()
{
  try
  {
    /***************************打开数据库 start ****************************/
    const char* db = 0, *server = 0, *user = 0, *password = "";
    db = "dreamview_web";
    server = "localhost";
    user = "root";
    password = "Aa123456";

    mysqlpp::Connection conn(false);
    if (conn.connect(db, server, user, password))
    {
      LOG(INFO)<<Name()<<":Canbus opendb dreamview_web succeed";
      std::string sRuleName="123456";
      std::string sDirectiveID = "7";
      std::string id = "10002";
      std::string s_sql="insert into Base_Department (Id,Name,ParentId)"
                        "VALUES (\'"+id+" \',\'"+sRuleName+"\',\'"+sDirectiveID+"\');";
      mysqlpp::Query query = conn.query(s_sql);
      mysqlpp::SimpleResult  res = query.execute();
     cout << "Inserted into Base_Department table, ID =" << res.insert_id() << endl;
    }
    else
    {
      LOG(INFO)<<Name()<<":Canbus opendb dreamview_web fail";
    }
    /***************************打开数据库 end ******************************/
    conn.disconnect();
    return DATABASE_SUCCESS;
  }
  catch (BadQuery er)
  { // handle any connection or
  // query errors that may come up
    LOG(ERROR)<<Name()<< " Canbus database error. "<< er.what();
    return DATABASE_FAILTURE;
  }
  catch (const BadConversion& er)
  {
  // Handle bad conversions
    LOG(ERROR)<<Name()<< " Canbus database Conversion error: "<< er.what()
             <<"\tretrieved data size: " << er.retrieved
             <<", actual size: " << er.actual_size;
    return DATABASE_FAILTURE;
  }
  catch (const Exception& er)
  {
    // Catch-all for any other MySQL++ exceptions
    LOG(ERROR)<<Name()<< " Canbus database error. "<< er.what();
    return DATABASE_FAILTURE;
  }

}

int CanbusMySqlDataBase::QuerySysPara(long id,RACK_SYS_PARA *rackSysPara)
{
  try
  {
    /***************************打开数据库 start ****************************/
    const char* db = 0, *server = 0, *user = 0, *password = "";
    db = "dreamview_web";
    server = "localhost";
    user = "root";
    password = "Aa123456";

    mysqlpp::Connection conn(false);
    if (conn.connect(db, server, user, password))
    {
      LOG(INFO)<<Name()<<":Canbus opendb dreamview_web succeed";
      std::string carId=std::to_string(id);
      std::string sql = "SELECT * FROM rack_syspara WHERE Id = "+carId+";";
      mysqlpp::Query query = conn.query(sql);
      mysqlpp::StoreQueryResult res = query.store();
      cout << "ares.num_rows() = " << res.num_rows() << endl;
      if(res.num_rows() <= 0)
      {
         return DATABASE_FAILTURE;
      }
      rackSysPara->Id = res[0]["Id"];
      rackSysPara->CarName = res[0]["CarName"].c_str();
      rackSysPara->P = res[0]["P"];
      rackSysPara->I = res[0]["I"];
      rackSysPara->D = res[0]["D"];
      rackSysPara->KP = res[0]["KP"];
      rackSysPara->KI = res[0]["KI"];
      rackSysPara->KD = res[0]["KD"];
      rackSysPara->BrkFactor = res[0]["BrkFactor"];
      rackSysPara->BrkMax = res[0]["BrkMax"];

    }
    else
    {
      LOG(INFO)<<Name()<<":Canbus opendb dreamview_web fail";
      return DATABASE_FAILTURE;
    }
    /***************************打开数据库 end ******************************/
    conn.disconnect();
    return DATABASE_SUCCESS;
  }
  catch (BadQuery er)
  { // handle any connection or
  // query errors that may come up
    LOG(ERROR)<<Name()<< " Canbus database error. "<< er.what();
    return DATABASE_FAILTURE;
  }
  catch (const BadConversion& er)
  {
  // Handle bad conversions
    LOG(ERROR)<<Name()<< " Canbus database Conversion error: "<< er.what()
             <<"\tretrieved data size: " << er.retrieved
             <<", actual size: " << er.actual_size;
    return DATABASE_FAILTURE;
  }
  catch (const Exception& er)
  {
    // Catch-all for any other MySQL++ exceptions
    LOG(ERROR)<<Name()<< " Canbus database error. "<< er.what();
    return DATABASE_FAILTURE;
  }

}

long CanbusMySqlDataBase::InsertTaskInfo(int CarType,
                                        std::string Standard,
                                        std::string DateTime,
                                        double OverThresholdValue,
                                        int StandardNum)
{
  try
  {
    /***************************打开数据库 start ****************************/
    const char* db = 0, *server = 0, *user = 0, *password = "";
    db = "dreamview_web";
    server = "localhost";
    user = "root";
    password = "Aa123456";

    mysqlpp::Connection conn(false);
    long insertId = -1;
    if (conn.connect(db, server, user, password))
    {
      LOG(INFO)<<Name()<<":Canbus opendb dreamview_web succeed";
      std::string dataCarType=std::to_string(CarType);
      std::string dataStandard=Standard;
      std::string dataDateTime=DateTime;
      std::string dataOverThresholdValue=std::to_string(OverThresholdValue);
      std::string dataStandardNum=std::to_string(StandardNum);
      std::string s_sql="INSERT INTO rack_taskinfo (CarType,Standard,DateTime,OverThresholdValue,StandardNum)"
                        "VALUES ("+dataCarType+",\'"+dataStandard+"\',\'"+dataDateTime+"\',"
                        ""+dataOverThresholdValue+","+dataStandardNum+");";
      mysqlpp::Query query = conn.query(s_sql);
      mysqlpp::SimpleResult  res = query.execute();
     LOG(INFO)<<Name()<<"Inserted into rack_taskinfo table, ID =" << res.insert_id();
     insertId = res.insert_id();
    }
    else
    {
      LOG(INFO)<<Name()<<":Canbus opendb dreamview_web fail";
      return DATABASE_FAILTURE;
    }
    /***************************打开数据库 end ******************************/
    conn.disconnect();
    return insertId;
  }
  catch (BadQuery er)
  { // handle any connection or
  // query errors that may come up
    LOG(ERROR)<<Name()<< " Canbus database error. "<< er.what();
    return DATABASE_FAILTURE;
  }
  catch (const BadConversion& er)
  {
  // Handle bad conversions
    LOG(ERROR)<<Name()<< " Canbus database Conversion error: "<< er.what()
             <<"\tretrieved data size: " << er.retrieved
             <<", actual size: " << er.actual_size;
    return DATABASE_FAILTURE;
  }
  catch (const Exception& er)
  {
    // Catch-all for any other MySQL++ exceptions
    LOG(ERROR)<<Name()<< " Canbus database error. "<< er.what();
    return DATABASE_FAILTURE;
  }

}

int CanbusMySqlDataBase::InsertTaskData(long TaskId,
                                        double SetSpeed,
                                        double ActualSpeed,
                                        long AccOrderPsng,
                                        long BrkOrderPsng,
                                        double StandardSpeedTimeStamp,
                                        int OverSpeedNum,
                                        int StandardTaskCount)
{
  try
  {
    /***************************打开数据库 start ****************************/
    const char* db = 0, *server = 0, *user = 0, *password = "";
    db = "dreamview_web";
    server = "localhost";
    user = "root";
    password = "Aa123456";

    mysqlpp::Connection conn(false);
    int insertId = -1;
    if (conn.connect(db, server, user, password))
    {
      LOG(INFO)<<Name()<<":Canbus opendb dreamview_web succeed";
      std::string dataTaskId=std::to_string(TaskId);
      std::string dataSetSpeed=std::to_string(SetSpeed);
      std::string dataActualSpeed=std::to_string(ActualSpeed);
      std::string dataAccOrderPsng=std::to_string(AccOrderPsng);
      std::string dataBrkOrderPsng=std::to_string(BrkOrderPsng);
      std::string dataStandardSpeedTimeStampe=std::to_string(StandardSpeedTimeStamp);
      std::string dataOverSpeedNum=std::to_string(OverSpeedNum);
      std::string dataStandardTaskCount = std::to_string(StandardTaskCount);
      std::string s_sql="INSERT INTO rack_taskdata "
                        "(TaskId,SetSpeed,ActualSpeed,AccOrderPsng,BrkOrderPsng,"
                        "StandardSpeedTimeStamp,OverSpeedNum,StandardTaskCount)"
                        "VALUES ("+dataTaskId+","+dataSetSpeed+","+dataActualSpeed+","
                        ""+dataAccOrderPsng+","+dataBrkOrderPsng+","
                        ""+dataStandardSpeedTimeStampe+","+dataOverSpeedNum+","+dataStandardTaskCount+");";
      mysqlpp::Query query = conn.query(s_sql);
      mysqlpp::SimpleResult  res = query.execute();
      LOG(INFO)<<Name()<<"Inserted into rack_taskdata table, ID =" << res.insert_id();
     insertId = res.insert_id();
     if(insertId <= 0)
     {
       LOG(INFO)<<Name()<<"insert rack_taskdata error";
     }
    }
    else
    {
      LOG(INFO)<<Name()<<":Canbus opendb dreamview_web fail";
      return DATABASE_FAILTURE;
    }
    /***************************打开数据库 end ******************************/
    conn.disconnect();
    return insertId;
  }
  catch (BadQuery er)
  { // handle any connection or
  // query errors that may come up
    LOG(ERROR)<<Name()<< " Canbus database error. "<< er.what();
    return DATABASE_FAILTURE;
  }
  catch (const BadConversion& er)
  {
  // Handle bad conversions
    LOG(ERROR)<<Name()<< " Canbus database Conversion error: "<< er.what()
             <<"\tretrieved data size: " << er.retrieved
             <<", actual size: " << er.actual_size;
    return DATABASE_FAILTURE;
  }
  catch (const Exception& er)
  {
    // Catch-all for any other MySQL++ exceptions
    LOG(ERROR)<<Name()<< " Canbus database error. "<< er.what();
    return DATABASE_FAILTURE;
  }

}

int CanbusMySqlDataBase::InsertTaskDataUI(long TaskId,
                                        double SetSpeed,
                                        double ActualSpeed,
                                        double StandardSpeedTimeStamp,
                                        int OverSpeedNum,
                                        int StandardTaskCount)
{
  try
  {
    /***************************打开数据库 start ****************************/
    const char* db = 0, *server = 0, *user = 0, *password = "";
    db = "dreamview_web";
    server = "localhost";
    user = "root";
    password = "Aa123456";

    mysqlpp::Connection conn(false);
    int insertId = -1;
    if (conn.connect(db, server, user, password))
    {
      LOG(INFO)<<Name()<<":Canbus opendb dreamview_web succeed";
      std::string dataTaskId=std::to_string(TaskId);
      std::string dataSetSpeed=std::to_string(SetSpeed);
      std::string dataActualSpeed=std::to_string(ActualSpeed);
      std::string dataStandardSpeedTimeStampe=std::to_string(StandardSpeedTimeStamp);
      std::string dataOverSpeedNum=std::to_string(OverSpeedNum);
      std::string dataStandardTaskCount = std::to_string(StandardTaskCount);
      std::string s_sql="INSERT INTO rack_taskdataui "
                        "(TaskId,SetSpeed,ActualSpeed,"
                        "StandardSpeedTimeStamp,OverSpeedNum,StandardTaskCount)"
                        "VALUES ("+dataTaskId+","+dataSetSpeed+","+dataActualSpeed+","
                        ""+dataStandardSpeedTimeStampe+","+dataOverSpeedNum+","+dataStandardTaskCount+");";
      mysqlpp::Query query = conn.query(s_sql);
      mysqlpp::SimpleResult  res = query.execute();
     LOG(INFO)<<Name()<<"Inserted into rack_taskdataui table, ID =" << res.insert_id();
     insertId = res.insert_id();
     if(insertId <= 0)
     {
       LOG(INFO)<<Name()<<"insert rack_taskdataui error";
     }
    }
    else
    {
      LOG(INFO)<<Name()<<":Canbus opendb dreamview_web fail";
      return DATABASE_FAILTURE;
    }
    /***************************打开数据库 end ******************************/
    conn.disconnect();
    return insertId;
  }
  catch (BadQuery er)
  { // handle any connection or
  // query errors that may come up
    LOG(ERROR)<<Name()<< " Canbus database error. "<< er.what();
    return DATABASE_FAILTURE;
  }
  catch (const BadConversion& er)
  {
  // Handle bad conversions
    LOG(ERROR)<<Name()<< " Canbus database Conversion error: "<< er.what()
             <<"\tretrieved data size: " << er.retrieved
             <<", actual size: " << er.actual_size;
    return DATABASE_FAILTURE;
  }
  catch (const Exception& er)
  {
    // Catch-all for any other MySQL++ exceptions
    LOG(ERROR)<<Name()<< " Canbus database error. "<< er.what();
    return DATABASE_FAILTURE;
  }

}

}// namespace canbusSpace
}// namespace robot
