/******************************************************************************
 * Copyright 2020 The siasun Transport Authors. All Rights Reserved.
 * Author: madesheng
 * Licensed under the Apache License, Version 1.0 (the "License");
 *****************************************************************************/


#ifndef ROBOT_COMMON_MESSAGECHANNELS_H_
#define ROBOT_COMMON_MESSAGECHANNELS_H_

#include <string>

/**
 * @namespace robot::common
 * @brief robot::common
 */
namespace robot{
namespace common{

// -----------------topics ----------------------------
const std::string Geometry = "geometry"; // utm coords

const std::string GeometryPlan = "geometryplan";

const std::string ControlInfo = "controlinfo";

const std::string RuleInfo = "ruleinfo";

const std::string CanDataAnalysis = "canDataAnalysis";

const std::string ObdData = "obddata";

const std::string AesData = "aesData";

const std::string SlData = "slData";

const std::string Si2Data = "si2Data";

const std::string SeData = "seData";

const std::string AcceData = "acceData";

const std::string BrkeData = "brkeData";

const std::string XsfteData = "xsfteData";

const std::string YsfteData = "ysfteData";

const std::string StreData = "streData";

const std::string EiData = "eiData";

const std::string EeData = "eeData";

const std::string PowerData = "powerData";

const std::string PedLrnPosData = "pedLrnPosData";

const std::string StrLrnPosData = "strLrnPosData";

const std::string SfLrnPos1Data = "sfLrnPos1Data";

const std::string SfLrnPos2Data = "sfLrnPos2Data";

const std::string Si1Data = "si1Data";

const std::string SmData = "smData";

const std::string ZSftData = "zsftData";

const std::string RackReplyData = "rackreplydata";

const std::string RackReplyDetailData = "rackreplydetaildata";
// -----------------topics ----------------------------

// -----------------services ----------------------------
const std::string LearnModeService = "learnmodeservice";

const std::string ActuatorEnableService = "actuatorenableservice";

const std::string ShiftActCtrService = "shiftactctrservice";

const std::string SteerActCtrService = "streeractstrservice";

const std::string AccPedalActCtrService = "accpedalactctrservice";

const std::string BrkPedalActCtrService = "brkpedalactctrservice";

const std::string CommandModeCmdService = "commandmodecmdservice";

const std::string RBTManagerService = "rbtmanagerservice";

const std::string PowerOnService = "poweronservice";

const std::string ActuatorCtrLimitService = "actuatorctrlimitservice";

const std::string VehicleStartService = "vehiclestartservice";

const std::string SlopeModeService = "slopemodeservice";

const std::string StrLoopService = "strloopservice";

const std::string AccLoopService = "accloopservice";

const std::string BrkLoopService = "brkloopservice";

const std::string StrTxtService = "strtxtservice";

const std::string BrkTxtService = "brktxtservice";

const std::string AccTxtService = "acctxtservice";

const std::string StrTxtLineService = "strtxtlineservice";

const std::string VehicleStatSetService  = "vehiclestatsetservice";

const std::string RbtDriverCtrlService = "rbtdriverctrlservice";

const std::string StrTangLineCtrService = "strtanglinectrservice";

const std::string StrPosTimCtrService = "strpostimctrservice";

const std::string StrSinCtrService = "strsinctrservice";

const std::string IOModeService = "iomodeservice";

const std::string RbtSlfChckCtrlReqService = "rbtslfchckctrlreqservice";

const std::string StrAccCtrlReqService = "straccctrlreqservice";

const std::string AccPosCtrlStpService = "accposctrlstpservice";

const std::string BrkTimCtrlStpService = "brktimctrlstpservice";

const std::string SysCtrlModeService = "sysctrlmodeservice";

const std::string RobotWorkMdService = "robotworkmdservice";

const std::string EstpCtrlService = "estpctrlservice";

const std::string SftTxtService = "sfttxtservice";

const std::string RackTestService = "racktestservice";
// -----------------services ----------------------------



} // common

} // robot




#endif  // ROBOT_COMMON_MESSAGECHANNELS_H_
