/******************************************************************************
 * Copyright 2020 The siasun Transport Authors. All Rights Reserved.
 * Author: madesheng
 * Licensed under the Apache License, Version 1.0 (the "License");
 *****************************************************************************/
#include "robotapp.h"

namespace robot {
namespace common {


int RobotApp::Spin() {
  ros::AsyncSpinner spinner(1);
  int status = Init();
  if (status != 0) {
    LOG(ERROR) << Name() << " Init failed: " << status;
    return -1;
  }
  status = Start();
  if (status != 0) {
    LOG(ERROR) << Name() << " Start failed: " << status;
    return -2;
  }

  spinner.start();
  ros::waitForShutdown();
  Stop();
  LOG(INFO) << Name() << " exited.";
  return 0;
}

void robot_app_sigint_handler(int signal_num) {
  LOG(INFO) << "Received signal: " << signal_num;
  if (signal_num != SIGINT) {
    return;
  }
  bool static is_stopping = false;
  if (is_stopping) {
    return;
  }
  is_stopping = true;
  ros::shutdown();
}

}  // namespace common
}  // namespace robot
